#!./uniperl
require "uniperl.pl";
require "soundex.pl";

&Init_Globals;
&Init_Synonyms;
&Init_Fields;
&Init_Tables;

sub Process_Entity_Children
{
	local($entity_field, $child_key, $child_field) = @_;

	local($rc) = &makeset($entity{'entity_key'}, $child_key, $first);
	if ($rc != 0) { print "makeset(entity.entity_key, $Synonym[$child_key], first) -> $rc\n"; return; }

	while ( !($rc = &nextrec($entity{'entity_key'}, $child_key)) ) {
		$rc = &gfield($child_field, $field);
		if ($rc != 0) { print "gfield($Field[$child_field]) -> $rc\n"; return; }
		if ($entity_field ne $field) {
			$n1 = $entity_field; $n1 =~ s/\s+$//;
			$n2 = $field; $n2 =~ s/\s+$//;
			print "Discrepency exists for '$n1' != '$n2' (fixing).\n" if ($n1 ne $n2);
			$rc = &pfield($child_field, $entity_field);
			if ($rc != 0) { print "pfield($Field[$child_field]) -> $rc\n"; return; }
		}
	}
	local($rc) = &clrset($entity{'entity_key'}, $child_key);
	if ($rc != 0) { print "clrset(entity.entity_key, $Synonym[$child_key]) -> $rc\n"; return; }
}

$thru_order = $first;
while (($status = &seqacc($entity, $thru_order)) == 0) {
	$thru_order = $next;
	$rc = &gfield($entity{'entity_key'}, $entity_key);
	if ($rc != 0) { print "gfield(entity.entity_key) -> $rc\n"; next; }
	next if ($entity_key == 0);

	$rc = &gfield($entity{'name'}, $name);
	if ($rc != 0) { print "gfield(entity.name) -> $rc\n"; next; }

	print "Processing $name...\n";

	for ($i=0; $i < $#entity_names; $i+=2) {
		&Process_Entity_Children($name, $entity_names[$i], $entity_names[$i+1]);
	}

	$rc = &gfield($entity{'code'}, $initials);
	if ($rc != 0) { print "gfield(entity.code) -> $rc\n"; next; }

	for ($i=0; $i < $#entity_inits; $i+=2) {
		&Process_Entity_Children($initials, $entity_inits[$i], $entity_inits[$i+1]);
	}
}

&closedb;
