#!./uniperl

require "uniperl.pl";
require "h/unisel.ph";

sub highlow
{
	&prmp(1, 14, "Enter the LOW purchase_price for the selection file:   ");
	&prmp(1, 16, "Enter the HIGH purchase_price for the selection file:  ");
	&prmp(1, 18, "Enter the LOW item quantity for the selection file: ");

	&gtube(56, 14, $itm_prcq, $low);
	&gtube(56, 16, $itm_prcq, $high);
	&gtube(56, 18, $itm_qty, $qty);
}

sub pritm
{
	local($y) = @_;

	if ($y == 8) {
		&prmp(1, 5, "order_number |");
		&prmp(15, 5, "line_number |");
		&prmp(30, 5, "stock_number |");
		&prmp(45, 5, "quantity |");
		&prmp(56, 5, "price_qtd |");
		&prmp(69, 5, "qty_shipped |");
		&prmp(82, 5, "status_code");
	}
	&pdata(1, $y, $itm_ord);
	&pdata(15, $y, $itm_lno);
	&pdata(30, $y, $itm_stk);
	&pdata(45, $y, $itm_qty);
	&pdata(56, $y, $itm_prcq);
	&pdata(69, $y, $itm_ship);
	&pdata(82, $y, $itm_stat);
}

&Init_Globals;
&Init_Tables;
&Init_Fields;

&clr_crt(1, 'a');

&prmp(4, 1, "PROGRAM TO LIST ITEM RECORDS HAVING A purchase_price OR A");
&prmp(13, 2, "quantity THAT FALLS IN A SPECIFIED RANGE");

&highlow($low, $high, $qty);

&clr_crt(1, 'a');
&prmp(0, 5, "Low purchase price:  ");
&ptube(22, 5, $itm_prcq, $low);
&prmp(39, 5, "High purchase price: ");
&ptube(60, 5,$itm_prcq, $high);
&prmp(21, 7, "Smallest quantity: ");
&ptube(40, 7, $itm_qty, $qty);

&prtmsg(0, 23, "Call UQSRCH");

$rc = &uqsrch("hi_lo", $itm_prcq, $low, $high, $EQ, $pcnt);

if ($pcnt == 0) {
	&prtmsg(0, 23, "There are no item records that satisfy price criteria");
} else {
	&prtmsg(0, 23, "rc = $rc     price count = $pcnt      ");
}

$rc = &uqsrch("quantity", $itm_qty, $qty, undef, $GTE, $qcnt);

if ($qcnt == 0) {
	&prtmsg(0, 23, "There are no item records that satisfy quantity criteria");
} else {
	&prtmsg(0, 23, "rc = $rc     quantity count = $qcnt      ");
}

if ($pcnt) {
	&prtmsg(0, 23, "Hit return to display price selection file");
	&clr_crt(1, 'a');
	&prmp(21, 1, "PRICE SELECTION FILE");
	&prmp(21, 2, "--------------------");

	$line = 1;
	$ss = &opensf("hi_lo");
	&frstsel($ss);

	do {
		if ( $line > 10 ) {
			&prtmsg(0, 23, "Hit return for next page");
			$line = 1;
			for ($i=10; $i; $i--) {
				&mv_cur(1, 0, $i+7);
				&eras_ln(1);
			}
		}
		&pritm($line+7);
		$line++;
	} while (&nextsel($ss) == 1);

	&closesf($ss);
}

if ($qcnt) {
	&prtmsg(0, 23, "Hit return to display quantity selection file");
	&clr_crt(1, 'a');
	&prmp(21, 1, "QUANTITY SELECTION FILE");
	&prmp(21, 2, "-----------------------");

	$line = 1;
	$ss = &opensf("quantity");
	&frstsel($ss);

	do {
		if ( $line > 10 ) {
			&prtmsg(0, 23, "Hit return for next page");
			$line = 1;
			for ($i=10; $i; $i--) {
				&mv_cur(1, 0, $i+7);
				&eras_ln(1);
			}
		}
		&pritm($line+7);
		$line++;
	} while (&nextsel($ss) == 1);

	&closesf($ss);
}

&setcook;
