/* $RCSfile$$Revision$$Date$
 *
 * $Log$
 */

#include <alloca.h>

#include "EXTERN.h"
#include "perl.h"

#include "btincl.h"
#include "unisel.h"
#include "dbtypes.h"
#include "fdesc.h"
#include "domains.h"
#include "udbflds.h"
#include "txlog.h"

static enum uservars {
	UV_No_Umsgs,
};

static enum usersubs {
	US_acckey,
	US_accsfld,
	US_addrec,
	US_atold,
	US_bfaccess,
	US_bgfield,
	US_bseqacc,
	US_bsetloc,
	US_btflds,
	US_btnext,
	US_btsrch,
	US_cfill,
	US_ckdirty,
	US_cleancrt,
	US_clearscr,
	US_copyrec,
	US_closbt,
	US_closedb,
	US_closesf,
	US_closetj,
	US_clossrt,
	US_clr_crt,
	US_clrfitm,
	US_clrset,
	US_clrsitm,
	US_comltg,
	US_delete,
	US_domchk,
	US_dspdt,
	US_dsply,
	US_endltg,
	US_endtrans,
	US_entsitm,
	US_eras_ln,
	US_erasprmp,
	US_faccess,
	US_fldesc,
	US_fldidxd,
	US_fldname,
	US_fldsyn,
	US_flush,
	US_frstsel,
	US_gdata,
	US_getdflt,
	US_getdoms,
	US_getintr,
	US_getnrec,
	US_gettrans,
	US_gfield,
	US_bingfield,
	US_glob,
	US_gsize,
	US_gtube,
	US_inbuf,
	US_inildt,
	US_iniubuf,
	US_input,
	US_inscrf,
	US_ivcmp,
	US_kdate,
	US_kday,
	US_keybrd,
	US_lastchr,
	US_ldfmt,
	US_ldtoa,
	US_ldtomdy,
	US_len,
	US_loadscr,
	US_loc,
	US_lock_r,
	US_lockrec,
	US_makeset,
	US_mdytold,
	US_mtchitm,
	US_mv_cur,
	US_nextrec,
	US_nextsel,
	US_numflds,
	US_numrecs,
	US_oblank,
	US_obuf,
	US_odata,
	US_opendb,
	US_opensf,
	US_opentj,
	US_opnbts,
	US_oprf,
	US_outbuf,
	US_output,
	US_outscrf,
	US_pdata,
	US_pfield,
	US_binpfield,
	US_pform,
	US_prevrec,
	US_prevsel,
	US_priamd,
	US_prmp,
	US_prmpf,
	US_prmprv,
	US_prstr,
	US_prtmsg,
	US_ptct_crt,
	US_ptct_wrt,
	US_ptube,
	US_qmove,
	US_reckey,
	US_recname,
	US_recsyn,
	US_samerec,
	US_scomp,
	US_selsort,
	US_seqacc,
	US_setcook,
	US_setintr,
	US_setloc,
	US_setraw,
	US_setsize,
	US_sfldesc,
	US_sfncitm,
	US_sfrstrec,
	US_slastrec,
	US_snextrec,
	US_sprevrec,
	US_startltg,
	US_startrans,
	US_strcmp,
	US_ufsel,
	US_ulockrec,
	US_unisel,
	US_unisort,
	US_unlock_r,
	US_uqmtch,
	US_uqsrch,
	US_valchar,
	US_valstr,
	US_yorn,
};

static int usersub();
static int userset();
static int userval();
static int str_buf_set();
static int str_field_buf_set();
static int str_sfld_buf_set();
static char *str_to_buf();
static char *str_to_field_buf();
static char *str_to_sfld_buf();
static int callback();
static int callv();
static int execute_subroutine();

static char *Subroutine;
static int Stack_Pointer;

int
init_uhli()
{
    struct ufuncs uf;
    char *filename = "uhli.c";
	extern char *V_prgnm;

	strcpy(V_prgnm, "uniperl");

    uf.uf_set = userset;
    uf.uf_val = userval;

#define MAGICVAR(name, ix) uf.uf_index = ix, magicname(name, &uf, sizeof uf)

    MAGICVAR("_No_Umsgs",	UV_No_Umsgs);

    make_usub("acckey",		US_acckey,		usersub, filename);
	make_usub("accsfld",	US_accsfld,		usersub, filename);
	make_usub("addrec",		US_addrec,		usersub, filename);
	make_usub("atold",		US_atold,		usersub, filename);
	make_usub("bfaccess",	US_bfaccess,	usersub, filename);
	make_usub("bgfield",	US_bgfield,		usersub, filename);
	make_usub("bseqacc",	US_bseqacc,		usersub, filename);
	make_usub("bsetloc",	US_bsetloc,		usersub, filename);
	make_usub("btflds",		US_btflds,		usersub, filename);
	make_usub("btnext",		US_btnext,		usersub, filename);
	make_usub("btsrch",		US_btsrch,		usersub, filename);
	make_usub("cfill",		US_cfill,		usersub, filename);
	make_usub("ckdirty",	US_ckdirty,		usersub, filename);
	make_usub("cleancrt",	US_cleancrt,	usersub, filename);
	make_usub("clearscr",	US_clearscr,	usersub, filename);
	make_usub("copyrec",	US_copyrec,		usersub, filename);
	make_usub("closbt",		US_closbt,		usersub, filename);
	make_usub("closedb",	US_closedb,		usersub, filename);
	make_usub("closesf",	US_closesf,		usersub, filename);
	make_usub("closetj",	US_closetj,		usersub, filename);
	make_usub("clossrt",	US_clossrt,		usersub, filename);
	make_usub("clr_crt",	US_clr_crt,		usersub, filename);
	make_usub("clrfitm",	US_clrfitm,		usersub, filename);
	make_usub("clrset",		US_clrset,		usersub, filename);
	make_usub("clrsitm",	US_clrsitm,		usersub, filename);
	make_usub("comltg",		US_comltg,		usersub, filename);
	make_usub("delete",		US_delete,		usersub, filename);
	make_usub("domchk",		US_domchk,		usersub, filename);
	make_usub("dspdt",		US_dspdt,		usersub, filename);
	make_usub("dsply",		US_dsply,		usersub, filename);
	make_usub("endltg",		US_endltg,		usersub, filename);
	make_usub("endtrans",	US_endtrans,	usersub, filename);
	make_usub("entsitm",	US_entsitm,		usersub, filename);
	make_usub("eras_ln",	US_eras_ln,		usersub, filename);
	make_usub("erasprmp",	US_erasprmp,	usersub, filename);
	make_usub("faccess",	US_faccess,		usersub, filename);
	make_usub("fldesc",		US_fldesc,		usersub, filename);
	make_usub("fldidxd",	US_fldidxd,		usersub, filename);
	make_usub("fldname",	US_fldname,		usersub, filename);
	make_usub("fldsyn",		US_fldsyn,		usersub, filename);
	make_usub("flush",		US_flush,		usersub, filename);
	make_usub("frstsel",	US_frstsel,		usersub, filename);
	make_usub("gdata",		US_gdata,		usersub, filename);
	make_usub("getdflt",	US_getdflt,		usersub, filename);
	make_usub("getdoms",	US_getdoms,		usersub, filename);
	make_usub("getintr",	US_getintr,		usersub, filename);
	make_usub("getnrec",	US_getnrec,		usersub, filename);
	make_usub("gettrans",	US_gettrans,	usersub, filename);
	make_usub("gfield",		US_gfield,		usersub, filename);
	make_usub("bingfield",	US_bingfield,	usersub, filename);
	make_usub("glob",		US_glob,		usersub, filename);
	make_usub("gsize",		US_gsize,		usersub, filename);
	make_usub("gtube",		US_gtube,		usersub, filename);
	make_usub("inbuf",		US_inbuf,		usersub, filename);
	make_usub("inildt",		US_inildt,		usersub, filename);
	make_usub("iniubuf",	US_iniubuf,		usersub, filename);
	make_usub("input",		US_input,		usersub, filename);
	make_usub("inscrf",		US_inscrf,		usersub, filename);
	make_usub("ivcmp",		US_ivcmp,		usersub, filename);
	make_usub("kdate",		US_kdate,		usersub, filename);
	make_usub("kday",		US_kday,		usersub, filename);
	make_usub("keybrd",		US_keybrd,		usersub, filename);
	make_usub("lastchr",	US_lastchr,		usersub, filename);
	make_usub("ldfmt",		US_ldfmt,		usersub, filename);
	make_usub("ldtoa",		US_ldtoa,		usersub, filename);
	make_usub("ldtomdy",	US_ldtomdy,		usersub, filename);
	make_usub("len",		US_len,			usersub, filename);
	make_usub("loadscr",	US_loadscr,		usersub, filename);
	make_usub("loc",		US_loc,			usersub, filename);
	make_usub("lock_r",		US_lock_r,		usersub, filename);
	make_usub("lockrec",	US_lockrec,		usersub, filename);
	make_usub("makeset",	US_makeset,		usersub, filename);
	make_usub("mdytold",	US_mdytold,		usersub, filename);
	make_usub("mtchitm",	US_mtchitm,		usersub, filename);
	make_usub("mv_cur",		US_mv_cur,		usersub, filename);
	make_usub("nextrec",	US_nextrec,		usersub, filename);
	make_usub("nextsel",	US_nextsel,		usersub, filename);
	make_usub("numflds",	US_numflds,		usersub, filename);
	make_usub("numrecs",	US_numrecs,		usersub, filename);
	make_usub("oblank",		US_oblank,		usersub, filename);
	make_usub("obuf",		US_obuf,		usersub, filename);
	make_usub("odata",		US_odata,		usersub, filename);
	make_usub("opendb",		US_opendb,		usersub, filename);
	make_usub("opensf",		US_opensf,		usersub, filename);
	make_usub("opentj",		US_opentj,		usersub, filename);
	make_usub("opnbts",		US_opnbts,		usersub, filename);
	make_usub("oprf",		US_oprf,		usersub, filename);
	make_usub("outbuf",		US_outbuf,		usersub, filename);
	make_usub("output",		US_output,		usersub, filename);
	make_usub("outscrf",	US_outscrf,		usersub, filename);
	make_usub("pdata",		US_pdata,		usersub, filename);
	make_usub("pfield",		US_pfield,		usersub, filename);
	make_usub("binpfield",	US_binpfield,	usersub, filename);
	make_usub("pform",		US_pform,		usersub, filename);
	make_usub("prevrec",	US_prevrec,		usersub, filename);
	make_usub("prevsel",	US_prevsel,		usersub, filename);
	make_usub("priamd",		US_priamd,		usersub, filename);
	make_usub("prmp",		US_prmp,		usersub, filename);
	make_usub("prmpf",		US_prmpf,		usersub, filename);
	make_usub("prmprv",		US_prmprv,		usersub, filename);
	make_usub("prstr",		US_prstr,		usersub, filename);
	make_usub("prtmsg",		US_prtmsg,		usersub, filename);
	make_usub("ptct_crt",	US_ptct_crt,	usersub, filename);
	make_usub("ptct_wrt",	US_ptct_wrt,	usersub, filename);
	make_usub("ptube",		US_ptube,		usersub, filename);
	make_usub("qmove",		US_qmove,		usersub, filename);
	make_usub("reckey",		US_reckey,		usersub, filename);
	make_usub("recname",	US_recname,		usersub, filename);
	make_usub("recsyn",		US_recsyn,		usersub, filename);
	make_usub("samerec",	US_samerec,		usersub, filename);
	make_usub("scomp",		US_scomp,		usersub, filename);
	make_usub("selsort",	US_selsort,		usersub, filename);
	make_usub("seqacc",		US_seqacc,		usersub, filename);
	make_usub("setcook",	US_setcook,		usersub, filename);
	make_usub("setintr",	US_setintr,		usersub, filename);
	make_usub("setloc",		US_setloc,		usersub, filename);
	make_usub("setraw",		US_setraw,		usersub, filename);
	make_usub("setsize",	US_setsize,		usersub, filename);
	make_usub("sfldesc",	US_sfldesc,		usersub, filename);
	make_usub("sfncitm",	US_sfncitm,		usersub, filename);
	make_usub("sfrstrec",	US_sfrstrec,	usersub, filename);
	make_usub("slastrec",	US_slastrec,	usersub, filename);
	make_usub("snextrec",	US_snextrec,	usersub, filename);
	make_usub("sprevrec",	US_sprevrec,	usersub, filename);
	make_usub("startltg",	US_startltg,	usersub, filename);
	make_usub("startrans",	US_startrans,	usersub, filename);
	make_usub("strcmp",		US_strcmp,		usersub, filename);
	make_usub("ufsel",		US_ufsel,		usersub, filename);
	make_usub("ulockrec",	US_ulockrec,	usersub, filename);
	make_usub("unisel",		US_unisel,		usersub, filename);
	make_usub("unisort",	US_unisort,		usersub, filename);
	make_usub("unlock_r",	US_unlock_r,	usersub, filename);
	make_usub("uqmtch",		US_uqmtch,		usersub, filename);
	make_usub("uqsrch",		US_uqsrch,		usersub, filename);
	make_usub("valchar",	US_valchar,		usersub, filename);
	make_usub("valstr",		US_valstr,		usersub, filename);
	make_usub("yorn",		US_yorn,		usersub, filename);
}
  
static int
usersub(ix, sp, items)
int ix;
register int sp;
register int items;
{
    STR **st = stack->ary_array + sp;
    register int i;
    register char *tmps;
    register STR *Str;		/* used in str_get and str_gnum macros */

    switch (ix) {

#if 0
    case US_acckey:
	if (items != 2)
	    fatal("Usage: &acckey($tnum, $key)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    char*	key =		(char*)		str_get(st[2]);

	    retval = acckey(tnum, key);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_acckey:
	if (items != 2)
	    fatal("Usage: &acckey($tnum, $key)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
		int		field =		(int)		reckey(tnum);
	    char*	key;

		if (field > 0) {
	    	key = (char*)str_to_field_buf(field, st[2]);
	    	retval = acckey(tnum, key);
		} else if (field == 0) {
			retval = -1;
		} else if (field < 0) {
			retval = -3;
		}

	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_accsfld:
	if (items != 3)
	    fatal("Usage: &accsfld($fnum, $pass, $priv)");
	else {
	    int retval;
	    int		fnum =		(int)		str_gnum(st[1]);
	    char*	pass =		(char*)		str_get(st[2]);
	    char	priv =		(char)		str_gnum(st[3]);

	    retval = accsfld(fnum, pass, priv);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_accsfld:
	if (items != 3)
	    fatal("Usage: &accsfld($fnum, $pass, $priv)");
	else {
	    int retval;
	    int		fnum =		(int)		str_gnum(st[1]);
	    char*	pass =		(char*)		str_get(st[2]);
	    char*	priv =		(char)		str_get(st[3]);

	    retval = accsfld(fnum, pass, *priv);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_addrec:
	if (items != 1)
	    fatal("Usage: &addrec($tnum)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = addrec(tnum);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_addrec:
	if (items < 1 || items > 3)
	    fatal("Usage: &addrec($tnum [, $key] [, $klist])");
	else {
	    int retval;
		int tnum;
		char *key;
		FIELDLIST *klist;

	    tnum = (int)str_gnum(st[1]);
		if (items == 2) {
			int key_field = (int)reckey(tnum);
			if (key_field > 0) {
				key = (char*)str_to_field_buf(key_field, st[2]);
			}
		} else if (items == 3) {
	    	klist = (FIELDLIST *)str_get(st[3]);
		}

	    retval = addrec(tnum, key, klist);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_atold:
	if (items != 2)
	    fatal("Usage: &atold($buf, $ldate)");
	else {
	    char* retval;
	    char*	buf =		(char*)		str_get(st[1]);
	    long	ldate;

	    retval = atold(buf, &ldate);
	    str_set(st[0], (char*) retval);
	    str_numset(st[2], (double) ldate);
	}
	return sp;


    case US_bfaccess:
	if (items != 2)
	    fatal("Usage: &bfaccess($tnum, $field)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    int		field =		(int)		str_gnum(st[2]);

	    retval = bfaccess(tnum, field);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_bgfield:
	if (items != 2)
	    fatal("Usage: &bgfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char	buf[256];

	    retval = bgfield(field, buf);
	    str_numset(st[0], (double) retval);
	    str_field_buf_set(&st[2], field, (char*) buf);
	}
	return sp;


    case US_bseqacc:
	if (items != 2)
	    fatal("Usage: &bseqacc($tnum, $direction)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    int		direction =	(int)		str_gnum(st[2]);

	    retval = bseqacc(tnum, direction);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_bsetloc:
	if (items != 2)
	    fatal("Usage: &bsetloc($tnum, $loc)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    long	loc =		(long)		str_gnum(st[2]);

	    retval = bsetloc(tnum, loc);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_btflds:
	if (items != 3)
	    fatal("Usage: &btflds($btree_id, $ptr, $dups_ok)");
	else {
	    int retval;
	    int		btree_id =	(int)		str_gnum(st[1]);
	    BTKDESC	ptr;
	    int		dups_ok;

	    retval = btflds(btree_id, &ptr, &dups_ok);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) ptr);

	    str_numset(st[3], (double) dups_ok);
	}
	return sp;
#endif
    case US_btflds:
	if (items != 3)
	    fatal("Usage: &btflds($btree_id, $ptr, $dups_ok)");
	else {
	    int retval;
	    int		btree_id =	(int)		str_gnum(st[1]);
	    BTKDESC	ptr[BTKDSIZ];
	    int		dups_ok;

	    retval = btflds(btree_id, ptr, &dups_ok);
	    str_numset(st[0], (double) retval);
	    str_nset(st[2], (char*)ptr, sizeof(ptr));

	    str_numset(st[3], (double) dups_ok);
	}
	return sp;


    case US_btnext:
	if (items != 1)
	    fatal("Usage: &btnext($btree_id)");
	else {
	    int retval;
	    int		btree_id =	(int)		str_gnum(st[1]);

	    retval = btnext(btree_id);
	    str_numset(st[0], (double) retval);
	}
	return sp;

#if 0
    case US_btsrch:
	if (items != 2)
	    fatal("Usage: &btsrch($btree_id, $ptrs)");
	else {
	    int retval;
	    int		btree_id =	(int)		str_gnum(st[1]);
	    char*	ptrs =		(char*)		str_get(st[2]);

	    retval = btsrch(btree_id, ptrs);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_btsrch:
	if (items < 2 || items > 9)
	    fatal("Usage: &btsrch($btree_id, $fld1 [, $fld2, .. $fld8])");
	else {
		int		n;
	    int		retval;
	    int		btree_id = (int)str_gnum(st[1]);
		char	*ptrs[BTKDSIZ];
	    BTKDESC	btfld[BTKDSIZ], *bt;
	    int		dups_ok;
		char	fldbuf[BTKDSIZ][256];

	    if ((retval = btflds(btree_id, btfld, &dups_ok)) == 0) {
			for (bt = btfld, n=0; (bt->fldno >= 0) && (n+2 <= items); bt++, n++) {
				char *data = (char*)str_to_field_buf(bt->fldno, st[n+2]);
				Move(data, fldbuf[n], sizeof(*bt), char);
				ptrs[n] = fldbuf[n];
			}
			ptrs[n] = NULL;
			if ((n+1 > items) && (bt->fldno >= 0)) {
				char fb[100];
				sprintf(fb, "&btsrch: more passed fields than btree fields for btree # %d", btree_id);
				fatal(fb);
			}
			retval = btsrch(btree_id, ptrs);
		}
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_cfill:
	if (items != 3)
	    fatal("Usage: &cfill($c, $str, $len)");
	else {
	    int retval = 1;
	    char	c =		(char)		str_gnum(st[1]);
	    char*	str =		(char*)		str_get(st[2]);
	    int		len =		(int)		str_gnum(st[3]);

	    (void)cfill(c, str, len);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) str);
	}
	return sp;
#endif
    case US_cfill:
	if (items != 3)
	    fatal("Usage: &cfill($c, $str, $len)");
	else {
	    int retval = 1;
	    char*	c =		(char)		str_get(st[1]);
	    char*	str =	(char*)		str_get(st[2]);
	    int		len =	(int)		str_gnum(st[3]);

	    (void)cfill(*c, str, len);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) str);
	}
	return sp;


    case US_ckdirty:
	if (items != 1)
	    fatal("Usage: &ckdirty($dbver)");
	else {
	    int retval;
	    int		dbver;

	    retval = ckdirty(&dbver);
	    str_numset(st[0], (double) retval);
	    str_numset(st[1], (double) dbver);
	}
	return sp;


    case US_cleancrt:
	if (items != 0)
	    fatal("Usage: &cleancrt()");
	else {
	    int retval = 1;

	    (void)cleancrt();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_clearscr:
	if (items != 0)
	    fatal("Usage: &clearscr()");
	else {
	    int retval = 1;

	    (void)clearscr();
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_copyrec:
	if (items != 3)
	    fatal("Usage: &copyrec($tnum, $source_key, $dest_key)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    char*	source_key =	(char*)		str_get(st[2]);
	    char*	dest_key =	(char*)		str_get(st[3]);

	    retval = copyrec(tnum, source_key, dest_key);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_copyrec:
	if (items != 3)
	    fatal("Usage: &copyrec($tnum, $source_key, $dest_key)");
	else {
	    int retval = 0;
		int tnum;
		char *buf;
		char source_key[256];
		char dest_key[256];
		long dflt, source, dest;
		char buffer[512];
		int key_field;
		int i, limit, rc, key;
		struct fdesc f;

	    tnum = (int)str_gnum(st[1]);
		key_field = (int)reckey(tnum);
		if (key_field > 0) {
			buf = (char*)str_to_field_buf(key_field, st[2]);
			Move(buf, source_key, sizeof(source_key), char);
			buf = (char*)str_to_field_buf(key_field, st[3]);
			Move(buf, dest_key, sizeof(dest_key), char);

			loc(tnum, &dflt);

			if ((rc=acckey(tnum, source_key)) != 0) {
				setloc(tnum, dflt);
				retval = -1;
			} else {
				loc(tnum, &source);
				if ((rc=addrec(tnum, dest_key)) != 0) {
					setloc(tnum, dflt);
					retval = -2;
				} else {
					loc(tnum, &dest);
					key = reckey(tnum);
					limit = numflds();
					for (i=1; i <= limit; i++) {
						if (fldesc(i, &f) == 0) continue;
						if (f.f_rec != tnum) continue;
						if (i == key || f.f_par == key) continue;
						if (f.f_typ == COMB) continue;
						setloc(tnum, source);
						gfield(i, buffer);
						setloc(tnum, dest);
						pfield(i, buffer);
					}
					setloc(tnum, dflt);
					retval = 0;
				}
			}
		} else {
			retval = -3;
		}

	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_closbt:
	if (items != 1)
	    fatal("Usage: &closbt($btree_id)");
	else {
	    int retval;
	    int		btree_id =	(int)		str_gnum(st[1]);

	    retval = closbt(btree_id);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_closedb:
	if (items != 0)
	    fatal("Usage: &closedb()");
	else {
	    int retval = 1;

	    (void)closedb();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_closesf:
	if (items != 1)
	    fatal("Usage: &closesf($sf)");
	else {
	    int retval = 1;
	    SELFILE*	sf =		*(SELFILE**)	str_get(st[1]);

	    (void)closesf(sf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_closetj:
	if (items != 0)
	    fatal("Usage: &closetj()");
	else {
	    int retval = 1;

	    (void)closetj();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_clossrt:
	if (items != 2)
	    fatal("Usage: &clossrt($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = clossrt(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_clr_crt:
	if (items != 2)
	    fatal("Usage: &clr_crt($fd, $flg)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);
	    char	flg =		(char)		str_gnum(st[2]);

	    (void)clr_crt(fd, flg);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_clr_crt:
	if (items != 2)
	    fatal("Usage: &clr_crt($fd, $flg)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);
	    char*	flg =		(char*)		str_get(st[2]);

	    (void)clr_crt(fd, *flg);
	    str_numset(st[0], (double) retval);
	}
	return sp;


/*** NOTE! NEEDS MORE CODE ***/
    case US_clrfitm:
	if (items != 1)
	    fatal("Usage: &clrfitm($(*sfnc)())");
	else {
	    int retval = 1;
	    int		(*sfnc)() =	(int)		str_gnum(st[1]);

	    (void)clrfitm((*sfnc)());
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_clrset:
	if (items != 2)
	    fatal("Usage: &clrset($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = clrset(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_clrsitm:
	if (items != 2)
	    fatal("Usage: &clrsitm($field, $rfield)");
	else {
	    int retval = 1;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    (void)clrsitm(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_comltg:
	if (items != 1)
	    fatal("Usage: &comltg($comment)");
	else {
	    int retval;
	    char*	comment =	(char*)		str_get(st[1]);

	    retval = comltg(comment);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_delete:
	if (items != 1)
	    fatal("Usage: &delete($tnum)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = delete(tnum);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_domchk:
	if (items != 2)
	    fatal("Usage: &domchk($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char*	buf =		(char*)		str_to_field_buf(field, st[2]);

	    retval = domchk(field, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_dspdt:
	if (items != 2)
	    fatal("Usage: &dspdt($buf, $str)");
	else {
	    int retval = 1;
	    int		buf =		(int)		str_gnum(st[1]);
	    char	str[256];

	    (void)dspdt(buf, str);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) str);
	}
	return sp;


    case US_dsply:
	if (items != 2)
	    fatal("Usage: &dsply($ssfld, $esfld)");
	else {
	    int retval = 1;
	    int		ssfld =		(int)		str_gnum(st[1]);
	    int		esfld =		(int)		str_gnum(st[2]);

	    (void)dsply(ssfld, esfld);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_endltg:
	if (items != 0)
	    fatal("Usage: &endltg()");
	else {
	    int retval;

	    retval = endltg();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_endtrans:
	if (items != 0)
	    fatal("Usage: &endtrans()");
	else {
	    int retval = 1;

	    (void)endtrans();
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_entsitm:
	if (items != 4)
	    fatal("Usage: &entsitm($field, $val1, $val2, $mode)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char*	val1 =		(char*)		str_to_field_buf(field, st[2]);
	    char*	val2 =		(char*)		str_to_field_buf(field, st[3]);
	    int		mode =		(int)		str_gnum(st[4]);

	    retval = entsitm(field, val1, val2, mode);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_entsitm:
	if (items != 4)
	    fatal("Usage: &entsitm($field, $val1, $val2, $mode)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		mode =		(int)		str_gnum(st[4]);
	    char*	val1;
	    char*	val2;
		char	buf[256];

	    val1 = (char*)str_to_field_buf(field, st[2]);
		Move(val1, buf, sizeof(buf), char);
		val1 = buf;
	    val2 = (char*)str_to_field_buf(field, st[3]);

	    retval = entsitm(field, val1, val2, mode);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_eras_ln:
	if (items != 1)
	    fatal("Usage: &eras_ln($fd)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);

	    (void)eras_ln(fd);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_erasprmp:
	if (items != 2)
	    fatal("Usage: &erasprmp($ssfld, $esfld)");
	else {
	    int retval = 1;
	    int		ssfld =		(int)		str_gnum(st[1]);
	    int		esfld =		(int)		str_gnum(st[2]);

	    (void)erasprmp(ssfld, esfld);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_faccess:
	if (items != 2)
	    fatal("Usage: &faccess($tnum, $field)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    int		field =		(int)		str_gnum(st[2]);

	    retval = faccess(tnum, field);
	    str_numset(st[0], (double) retval);
	}
	return sp;

#if 0
    case US_fldesc:
	if (items != 2)
	    fatal("Usage: &fldesc($field, $fdsc)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    FLDESC*	fdsc;

	    retval = fldesc(field, fdsc);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) fdsc);
	}
	return sp;
#endif
    case US_fldesc:
	if (items != 7)
	    fatal("Usage: &fldesc($field, $rec, $typ, $len, $par, $rprec, $rpfld)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    FLDESC	fdsc;

	    retval = fldesc(field, &fdsc);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) fdsc.f_rec);
	    str_numset(st[3], (double) fdsc.f_typ);
	    str_numset(st[4], (double) fdsc.f_len);
	    str_numset(st[5], (double) fdsc.f_par);
	    str_numset(st[6], (double) fdsc.f_rprec);
	    str_numset(st[7], (double) fdsc.f_rpfld);
	}
	return sp;


    case US_fldidxd:
	if (items != 2)
	    fatal("Usage: &fldidxd($field, $status)");
	else {
	    BTIDS* retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		status;

	    retval = fldidxd(field, &status);
	    str_nset(st[0], (char*) &retval, sizeof retval);
	    str_numset(st[2], (double) status);
	}
	return sp;


    case US_fldname:
	if (items != 1)
	    fatal("Usage: &fldname($fld)");
	else {
	    char* retval;
	    int		fld =		(int)		str_gnum(st[1]);

	    retval = fldname(fld);
	    str_set(st[0], (char*) retval);
	}
	return sp;


    case US_fldsyn:
	if (items != 1)
	    fatal("Usage: &fldsyn($fld)");
	else {
	    char* retval;
	    int		fld =		(int)		str_gnum(st[1]);

	    retval = fldsyn(fld);
	    str_set(st[0], (char*) retval);
	}
	return sp;


    case US_flush:
	if (items != 1)
	    fatal("Usage: &flush($fd)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);

	    (void)flush(fd);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_frstsel:
	if (items != 1)
	    fatal("Usage: &frstsel($sf)");
	else {
	    int retval;
	    SELFILE*	sf =		*(SELFILE**)	str_get(st[1]);

	    retval = frstsel(sf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_gdata:
	if (items != 3)
	    fatal("Usage: &gdata($fx, $fy, $field)");
	else {
	    int retval;
	    int		fx =		(int)		str_gnum(st[1]);
	    int		fy =		(int)		str_gnum(st[2]);
	    int		field =		(int)		str_gnum(st[3]);

	    retval = gdata(fx, fy, field);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_getdflt:
	if (items != 2)
	    fatal("Usage: &getdflt($field, $estat)");
	else {
	    U_DBVAL* retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		estat;

	    retval = getdflt(field, &estat);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) estat);
	}
	return sp;
#endif
    case US_getdflt:
	if (items != 2)
	    fatal("Usage: &getdflt($field, $estat)");
	else {
	    U_DBVAL *retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		estat;

	    retval = getdflt(field, &estat);
		str_field_buf_set(&st[0], field, retval);
	    str_numset(st[2], (double) estat);
	}
	return sp;


    case US_getdoms:
	if (items != 2)
	    fatal("Usage: &getdoms($field, $which)");
	else {
	    char* retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		which =		(int)		str_gnum(st[2]);

	    retval = getdoms(field, which);
	    str_set(st[0], (char*) retval);
	}
	return sp;


    case US_getintr:
	if (items != 0)
	    fatal("Usage: &getintr()");
	else {
	    int retval;

	    retval = getintr();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_getnrec:
	if (items != 1)
	    fatal("Usage: &getnrec($tnum)");
	else {
	    long retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = getnrec(tnum);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_gettrans:
	if (items != 1)
	    fatal("Usage: &gettrans($txbuf)");
	else {
	    int retval;
	    struct txtag*	txbuf =		(struct txtag*)	str_get(st[1]);

	    retval = gettrans(txbuf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_gfield:
	if (items != 2)
	    fatal("Usage: &gfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char	buf[256];

	    retval = gfield(field, buf);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) buf);
	}
	return sp;
#endif
    case US_gfield:
	if (items < 2 || items > 3)
	    fatal("Usage: &gfield($field, $buf [, $flist])");
	else {
	    int retval;
		FIELDLIST* flist;
	    int		field =		(int)		str_gnum(st[1]);
	    char	buf[256];

		if (items == 2) {
	    	retval = gfield(field, buf);
			str_field_buf_set(&st[2], field, buf);
		} else {
	    	retval = gfield(field, (char *)0, flist);
	    	str_nset(st[3], (char*) flist, sizeof(*flist));
		}
	    str_numset(st[0], (double) retval);
	}
	return sp;

#if 0
    case US_bingfield:
	if (items != 2)
	    fatal("Usage: &bingfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char	buf[256];

	    retval = bingfield(field, buf);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) buf);
	}
	return sp;
#endif
    case US_bingfield:
	if (items != 2)
	    fatal("Usage: &bingfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char	buf[256];

	    retval = gfield(field, buf);
	    str_numset(st[0], (double) retval);
	    str_nset(st[2], (char*) buf, sizeof buf);
	}
	return sp;

    case US_glob:
	if (items != 2)
	    fatal("Usage: &glob($strng, $mask)");
	else {
	    int retval;
	    char*	strng =		(char*)		str_get(st[1]);
	    char*	mask =		(char*)		str_get(st[2]);

	    retval = glob(strng, mask);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_gsize:
	if (items != 2)
	    fatal("Usage: &gsize($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char	buf[256];

	    retval = gsize(field, buf);
	    str_numset(st[0], (double) retval);
	    str_field_buf_set(&st[2], field, (char*) buf);
	}
	return sp;


    case US_gtube:
	if (items != 4)
	    fatal("Usage: &gtube($fx, $fy, $field, $buf)");
	else {
	    int retval;
	    int		fx =		(int)		str_gnum(st[1]);
	    int		fy =		(int)		str_gnum(st[2]);
	    int		field =		(int)		str_gnum(st[3]);
	    char	buf[256];

	    retval = gtube(fx, fy, field, buf);
	    str_numset(st[0], (double) retval);
	    str_field_buf_set(&st[4], field, (char*) buf);
	}
	return sp;


    case US_inbuf:
	if (items != 2)
	    fatal("Usage: &inbuf($sfld, $buf)");
	else {
	    int retval;
	    int		sfld =		(int)		str_gnum(st[1]);
	    char	buf[256];

	    retval = inbuf(sfld, buf);
	    str_numset(st[0], (double) retval);
	    str_sfld_buf_set(&st[2], sfld, (char*) buf);
	}
	return sp;


    case US_inildt:
	if (items != 0)
	    fatal("Usage: &inildt()");
	else {
	    int retval;

	    retval = inildt();
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_iniubuf:
	if (items != 2)
	    fatal("Usage: &iniubuf($bufaddr, $bufsz)");
	else {
	    int retval = 1;
	    char*	bufaddr =	(char*)		str_get(st[1]);
	    int		bufsz =		(int)		str_gnum(st[2]);

	    (void)iniubuf(bufaddr, bufsz);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_iniubuf:
	if (items < 1 || items > 2)
	    fatal("Usage: &iniubuf($bufaddr [ignored], $bufsz)");
	else {
	    int retval = 1;
	    int		bufsz =		(int)		str_gnum(st[items]);
	    char*	bufaddr =	(char*)malloc(bufsz);
		if (!bufaddr) retval = 0;	

	    (void)iniubuf(bufaddr, bufsz);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_input:
	if (items != 1)
	    fatal("Usage: &input($sfld)");
	else {
	    int retval;
	    int		sfld =		(int)		str_gnum(st[1]);

	    retval = input(sfld);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_inscrf:
	if (items != 5)
	    fatal("Usage: &inscrf($x, $y, $type, $len, $buf)");
	else {
	    int retval;
	    int		x =		(int)		str_gnum(st[1]);
	    int		y =		(int)		str_gnum(st[2]);
	    int		type =		(int)		str_gnum(st[3]);
	    int		len =		(int)		str_gnum(st[4]);
	    char	buf[256];

	    retval = inscrf(x, y, type, len, buf);
	    str_numset(st[0], (double) retval);
	    str_set(st[5], (char*) buf);
	}
	return sp;


    case US_ivcmp:
	if (items != 3)
	    fatal("Usage: &ivcmp($ptr1, $ptr2, $length)");
	else {
	    int retval;
	    char*	ptr1 =		(char*)		str_get(st[1]);
	    char*	ptr2 =		(char*)		str_get(st[2]);
	    int		length =	(int)		str_gnum(st[3]);

	    retval = ivcmp(ptr1, ptr2, length);
	    str_numset(st[0], (double) retval);
	}
	return sp;

#if 0
    case US_kdate:
	if (items != 2)
	    fatal("Usage: &kdate($jday, $arr[3])");
	else {
	    int retval = 1;
	    int		jday =		(int)		str_gnum(st[1]);
	    int		arr[3];

	    (void)kdate(jday, &arr[3]);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) arr[3]);
	}
	return sp;
#endif
    case US_kdate:
	if (items != 4)
	    fatal("Usage: &kdate($jday, $month, $day, $year)");
	else {
	    int retval = 1;
	    int		jday =		(int)		str_gnum(st[1]);
	    int		arr[3];

	    (void)kdate(jday, arr);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) arr[0]);
	    str_numset(st[3], (double) arr[1]);
	    str_numset(st[4], (double) arr[2]);
	}
	return sp;


#if 0
    case US_kday:
	if (items != 1)
	    fatal("Usage: &kday($arr[3])");
	else {
	    int retval;
	    int		arr[3] =	(int)		str_gnum(st[1]);

	    retval = kday(arr[3]);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_kday:
	if (items != 3)
	    fatal("Usage: &kday($month, $day, $year)");
	else {
	    int retval;
	    int		arr[3];
	    arr[0] =	(int)str_gnum(st[1]);
	    arr[1] =	(int)str_gnum(st[2]);
	    arr[2] =	(int)str_gnum(st[3]);

	    retval = kday(arr);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_keybrd:
	if (items != 2)
	    fatal("Usage: &keybrd($fd, $flg)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);
	    int		flg =		(int)		str_gnum(st[2]);

	    (void)keybrd(fd, flg);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_lastchr:
	if (items != 2)
	    fatal("Usage: &lastchr($strng, $len)");
	else {
	    int retval;
	    char*	strng =		(char*)		str_get(st[1]);
	    int		len =		(int)		str_gnum(st[2]);

	    retval = lastchr(strng, len);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_ldfmt:
	if (items != 1)
	    fatal("Usage: &ldfmt($buf)");
	else {
	    int retval = 1;
	    char	buf[256];

	    (void)ldfmt(buf);
	    str_numset(st[0], (double) retval);
	    str_set(st[1], (char*) buf);
	}
	return sp;


    case US_ldtoa:
	if (items != 2)
	    fatal("Usage: &ldtoa($ldate, $buf)");
	else {
	    int retval;
	    long	ldate =		(long)		str_gnum(st[1]);
	    char	buf[256];

	    retval = ldtoa(ldate, buf);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) buf);
	}
	return sp;


#if 0
    case US_ldtomdy:
	if (items != 2)
	    fatal("Usage: &ldtomdy($ldate, $mdy[3])");
	else {
	    int retval;
	    long	ldate =		(long)		str_gnum(st[1]);
	    int		mdy[3];

	    retval = ldtomdy(ldate, &mdy[3]);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) mdy[3]);
	}
	return sp;
#endif
    case US_ldtomdy:
	if (items != 4)
	    fatal("Usage: &ldtomdy($ldate, $month, $day, $year)");
	else {
	    int retval;
	    long	ldate =		(long)		str_gnum(st[1]);
	    int		mdy[3];

	    retval = ldtomdy(ldate, mdy);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) mdy[0]);
	    str_numset(st[3], (double) mdy[1]);
	    str_numset(st[4], (double) mdy[2]);
	}
	return sp;


    case US_len:
	if (items != 1)
	    fatal("Usage: &len($str)");
	else {
	    int retval;
	    char*	str =		(char*)		str_get(st[1]);

	    retval = len(str);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_loadscr:
	if (items != 1)
	    fatal("Usage: &loadscr($scrn)");
	else {
	    int retval = 1;
	    char*	scrn =		(char*)		str_get(st[1]);

	    (void)loadscr(scrn);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_loc:
	if (items != 2)
	    fatal("Usage: &loc($tnum, $addr)");
	else {
	    int retval = 1;
	    int		tnum =		(int)		str_gnum(st[1]);
	    long	addr;

	    (void)loc(tnum, &addr);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) addr);
	}
	return sp;


#if 0
    case US_lock_r:
	if (items != 1)
	    fatal("Usage: &lock_r($c)");
	else {
	    int retval = 1;
	    char	c =		(char)		str_gnum(st[1]);

	    (void)lock_r(c);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_lock_r:
	if (items != 1)
	    fatal("Usage: &lock_r($c)");
	else {
	    int retval = 1;
	    char*	c =		(char)		str_get(st[1]);

	    (void)lock_r(*c);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_lockrec:
	if (items != 1)
	    fatal("Usage: &lockrec($tnum)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = lockrec(tnum);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_makeset:
	if (items != 3)
	    fatal("Usage: &makeset($field, $rfield, $direction)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);
	    int		direction =	(int)		str_gnum(st[3]);

	    retval = makeset(field, rfield, direction);
	    str_numset(st[0], (double) retval);
	}
	return sp;

#if 0
    case US_mdytold:
	if (items != 2)
	    fatal("Usage: &mdytold($mdy[3], $ldate)");
	else {
	    int retval;
	    int		mdy[3] =	(int)		str_gnum(st[1]);
	    long	ldate;

	    retval = mdytold(mdy[3], &ldate);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) ldate);
	}
	return sp;
#endif
    case US_mdytold:
	if (items != 4)
	    fatal("Usage: &mdytold($month, $day, $year, $ldate)");
	else {
	    int retval;
	    int		mdy[3];
	    long	ldate;
	    mdy[0] =	(int)		str_gnum(st[1]);
	    mdy[1] =	(int)		str_gnum(st[2]);
	    mdy[2] =	(int)		str_gnum(st[3]);

	    retval = mdytold(mdy, &ldate);
	    str_numset(st[0], (double) retval);
	    str_numset(st[4], (double) ldate);
	}
	return sp;


    case US_mtchitm:
	if (items != 3)
	    fatal("Usage: &mtchitm($selfile, $rfield, $field)");
	else {
	    int retval;
	    char*	selfile =	(char*)		str_get(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);
	    int		field =		(int)		str_gnum(st[3]);

	    retval = mtchitm(selfile, rfield, field);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_mv_cur:
	if (items != 3)
	    fatal("Usage: &mv_cur($fd, $x, $y)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);
	    int		x =		(int)		str_gnum(st[2]);
	    int		y =		(int)		str_gnum(st[3]);

	    (void)mv_cur(fd, x, y);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_nextrec:
	if (items != 2)
	    fatal("Usage: &nextrec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = nextrec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_nextsel:
	if (items != 1)
	    fatal("Usage: &nextsel($sf)");
	else {
	    int retval;
	    SELFILE*	sf =		*(SELFILE**)	str_get(st[1]);

	    retval = nextsel(sf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_numflds:
	if (items != 0)
	    fatal("Usage: &numflds()");
	else {
	    int retval;

	    retval = numflds();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_numrecs:
	if (items != 0)
	    fatal("Usage: &numrecs()");
	else {
	    int retval;

	    retval = numrecs();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_oblank:
	if (items != 0)
	    fatal("Usage: &oblank()");
	else {
	    int retval = 1;

	    (void)oblank();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_obuf:
	if (items != 3)
	    fatal("Usage: &obuf($col, $field, $buf)");
	else {
	    int retval = 1;
	    int		col =		(int)		str_gnum(st[1]);
	    int		field =		(int)		str_gnum(st[2]);
	    char*	buf =		(char*)		str_to_field_buf(field, st[3]);

	    (void)obuf(col, field, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_odata:
	if (items != 2)
	    fatal("Usage: &odata($col, $field)");
	else {
	    int retval = 1;
	    int		col =		(int)		str_gnum(st[1]);
	    int		field =		(int)		str_to_field_buf(field, st[2]);

	    (void)odata(col, field);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_opendb:
	if (items != 2)
	    fatal("Usage: &opendb($dbname, $opt)");
	else {
	    int retval = 1;
	    char*	dbname =	(char*)		str_get(st[1]);
	    int		opt =		(int)		str_gnum(st[2]);

	    (void)opendb(dbname, opt);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_opensf:
	if (items != 1)
	    fatal("Usage: &opensf($selfile)");
	else {
	    SELFILE* retval;
	    char*	selfile =	(char*)		str_get(st[1]);

	    retval = opensf(selfile);
	    str_nset(st[0], (char*) &retval, sizeof retval);
	}
	return sp;


    case US_opentj:
	if (items != 0)
	    fatal("Usage: &opentj()");
	else {
	    int retval;

	    retval = opentj();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_opnbts:
	if (items != 1)
	    fatal("Usage: &opnbts($btree_id)");
	else {
	    int retval;
	    int		btree_id =	(int)		str_gnum(st[1]);

	    retval = opnbts(btree_id);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_oprf:
	if (items != 0)
	    fatal("Usage: &oprf()");
	else {
	    int retval;

	    retval = oprf();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_outbuf:
	if (items != 2)
	    fatal("Usage: &outbuf($sfld, $buf)");
	else {
	    int retval = 1;
	    int		sfld =		(int)		str_gnum(st[1]);
	    char*	buf =		(char*)		str_to_sfld_buf(sfld, st[2]);

	    (void)outbuf(sfld, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_output:
	if (items != 1)
	    fatal("Usage: &output($sfld)");
	else {
	    int retval = 1;
	    int		sfld =		(int)		str_gnum(st[1]);

	    (void)output(sfld);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_outscrf:
	if (items != 5)
	    fatal("Usage: &outscrf($fx, $fy, $type, $len, $buf)");
	else {
	    int retval = 1;
	    int		fx =		(int)		str_gnum(st[1]);
	    int		fy =		(int)		str_gnum(st[2]);
	    int		type =		(int)		str_gnum(st[3]);
	    int		len =		(int)		str_gnum(st[4]);
	    char*	buf =		(char*)		str_to_buf(type, st[5]);

	    (void)outscrf(fx, fy, type, len, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_pdata:
	if (items != 3)
	    fatal("Usage: &pdata($fx, $fy, $field)");
	else {
	    int retval = 1;
	    int		fx =		(int)		str_gnum(st[1]);
	    int		fy =		(int)		str_gnum(st[2]);
	    int		field =		(int)		str_gnum(st[3]);

	    (void)pdata(fx, fy, field);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_pfield:
	if (items != 2)
	    fatal("Usage: &pfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char*	buf =		(char*)		str_get(st[2]);

	    retval = pfield(field, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_pfield:
	if (items < 2 || items > 3)
	    fatal("Usage: &pfield($field, $buf [, $flist])");
	else {
	    int retval;
	    FIELDLIST*	flist;
	    int field = (int)str_gnum(st[1]);

		if (items == 2) {
	    	retval = pfield(field, str_to_field_buf(field, st[2]));
		} else {
	    	flist =	*(FIELDLIST**)str_get(st[3]);
	    	retval = pfield(field, (char *)0, flist);
		}
	    str_numset(st[0], (double)retval);
	}
	return sp;

#if 0
    case US_binpfield:
	if (items != 2)
	    fatal("Usage: &binpfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char*	buf =		(char*)		str_get(st[2]);

	    retval = binpfield(field, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_binpfield:
	if (items != 2)
	    fatal("Usage: &binpfield($field, $buf)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    char*	buf =		(char*)		str_get(st[2]);

	    retval = pfield(field, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;

/*** NOTE! NEEDS MORE CODE ***/
    case US_pform:
	if (items != 3)
	    fatal("Usage: &pform($xbuf, $ofd, $pftab)");
	else {
	    int retval;
	    char*	xbuf =		(char*)		str_get(st[1]);
	    int		ofd =		(int)		str_gnum(st[2]);
	    char*	pftab =		(char*)		str_get(st[3]);

	    retval = pform(xbuf, ofd, pftab);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prevrec:
	if (items != 2)
	    fatal("Usage: &prevrec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = prevrec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prevsel:
	if (items != 1)
	    fatal("Usage: &prevsel($sf)");
	else {
	    int retval;
	    SELFILE*	sf =		*(SELFILE**)	str_get(st[1]);

	    retval = prevsel(sf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_priamd:
	if (items != 1)
	    fatal("Usage: &priamd($line)");
	else {
	    int retval;
	    int		line =		(int)		str_gnum(st[1]);

	    retval = priamd(line);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prmp:
	if (items != 3)
	    fatal("Usage: &prmp($x, $y, $str)");
	else {
	    int retval = 1;
	    int		x =		(int)		str_gnum(st[1]);
	    int		y =		(int)		str_gnum(st[2]);
	    char*	str =		(char*)		str_get(st[3]);

	    (void)prmp(x, y, str);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prmpf:
	if (items != 3)
	    fatal("Usage: &prmpf($x, $y, $str)");
	else {
	    int retval = 1;
	    int		x =		(int)		str_gnum(st[1]);
	    int		y =		(int)		str_gnum(st[2]);
	    char*	str =		(char*)		str_get(st[3]);

	    (void)prmpf(x, y, str);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prmprv:
	if (items != 3)
	    fatal("Usage: &prmprv($x, $y, $str)");
	else {
	    int retval = 1;
	    int		x =		(int)		str_gnum(st[1]);
	    int		y =		(int)		str_gnum(st[2]);
	    char*	str =		(char*)		str_get(st[3]);

	    (void)prmprv(x, y, str);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prstr:
	if (items != 2)
	    fatal("Usage: &prstr($str, $col)");
	else {
	    int retval = 1;
	    char*	str =		(char*)		str_get(st[1]);
	    int		col =		(int)		str_gnum(st[2]);

	    (void)prstr(str, col);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_prtmsg:
	if (items != 3)
	    fatal("Usage: &prtmsg($x, $y, $strng)");
	else {
	    int retval = 1;
	    int		x =		(int)		str_gnum(st[1]);
	    int		y =		(int)		str_gnum(st[2]);
	    char*	strng =		(char*)		str_get(st[3]);

	    (void)prtmsg(x, y, strng);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_ptct_crt:
	if (items != 2)
	    fatal("Usage: &ptct_crt($fd, $flg)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);
	    int		flg =		(int)		str_gnum(st[2]);

	    (void)ptct_crt(fd, flg);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_ptct_wrt:
	if (items != 2)
	    fatal("Usage: &ptct_wrt($fd, $flg)");
	else {
	    int retval = 1;
	    int		fd =		(int)		str_gnum(st[1]);
	    int		flg =		(int)		str_gnum(st[2]);

	    (void)ptct_wrt(fd, flg);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_ptube:
	if (items != 4)
	    fatal("Usage: &ptube($fx, $fy, $field, $buf)");
	else {
	    int retval = 1;
	    int		fx =		(int)		str_gnum(st[1]);
	    int		fy =		(int)		str_gnum(st[2]);
	    int		field =		(int)		str_gnum(st[3]);
	    char*	buf =		(char*)		str_to_field_buf(field, st[4]);

	    (void)ptube(fx, fy, field, buf);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_qmove:
	if (items != 3)
	    fatal("Usage: &qmove($str1, $str2, $len)");
	else {
	    int retval = 1;
	    char*	str1 =		(char*)		str_get(st[1]);
	    char*	str2 =		(char*)		str_get(st[2]);
	    int		len =		(int)		str_gnum(st[3]);

	    (void)qmove(str1, str2, len);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_reckey:
	if (items != 1)
	    fatal("Usage: &reckey($tnum)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = reckey(tnum);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_recname:
	if (items != 1)
	    fatal("Usage: &recname($tnum)");
	else {
	    char* retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = recname(tnum);
	    str_set(st[0], (char*) retval);
	}
	return sp;


    case US_recsyn:
	if (items != 1)
	    fatal("Usage: &recsyn($tnum)");
	else {
	    char* retval;
	    int		tnum =		(int)		str_gnum(st[1]);

	    retval = recsyn(tnum);
	    str_set(st[0], (char*) retval);
	}
	return sp;


    case US_samerec:
	if (items != 2)
	    fatal("Usage: &samerec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = samerec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_scomp:
	if (items != 3)
	    fatal("Usage: &scomp($str1, $str2, $len)");
	else {
	    int retval;
	    char*	str1 =		(char*)		str_get(st[1]);
	    char*	str2 =		(char*)		str_get(st[2]);
	    int		len =		(int)		str_gnum(st[3]);

	    retval = scomp(str1, str2, len);
	    str_numset(st[0], (double) retval);
	}
	return sp;


/*** NOTE! NEEDS MORE CODE ***/
    case US_selsort:
	if (items != 3)
	    fatal("Usage: &selsort($tnum, $fldtbl, $functbl)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    int*	fldtbl =	(int*)		str_gnum(st[2]);
	    int*	functbl =	(int*)		str_gnum(st[3]);

	    retval = selsort(tnum, fldtbl, functbl);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_seqacc:
	if (items != 2)
	    fatal("Usage: &seqacc($tnum, $direction)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    int		direction =	(int)		str_gnum(st[2]);

	    retval = seqacc(tnum, direction);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_setcook:
	if (items != 0)
	    fatal("Usage: &setcook()");
	else {
	    int retval = 1;

	    (void)setcook();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_setintr:
	if (items != 1)
	    fatal("Usage: &setintr($newval)");
	else {
	    int retval;
	    int		newval =	(int)		str_gnum(st[1]);

	    retval = setintr(newval);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_setloc:
	if (items != 2)
	    fatal("Usage: &setloc($tnum, $loc)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    long	loc =		(long)		str_gnum(st[2]);

	    retval = setloc(tnum, loc);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_setraw:
	if (items != 0)
	    fatal("Usage: &setraw()");
	else {
	    int retval = 1;

	    (void)setraw();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_setsize:
	if (items != 3)
	    fatal("Usage: &setsize($field, $rfield, $count)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);
	    long	count;

	    retval = setsize(field, rfield, &count);
	    str_numset(st[0], (double) retval);
	    str_numset(st[3], (double) count);
	}
	return sp;


#if 0
    case US_sfldesc:
	if (items != 2)
	    fatal("Usage: &sfldesc($sfield, $sfdsc)");
	else {
	    int retval;
	    int		sfield =	(int)		str_gnum(st[1]);
	    SFLDESC*	sfdsc;

	    retval = sfldesc(sfield, sfdsc);
	    str_numset(st[0], (double) retval);
	    str_set(st[2], (char*) sfdsc);
	}
	return sp;
#endif
    case US_sfldesc:
	if (items != 4)
	    fatal("Usage: &sfldesc($sfield, $sf_fld, $sf_col, $sf_lin)");
	else {
	    int retval;
	    int		sfield =	(int)		str_gnum(st[1]);
	    SFLDESC	sfdsc;

	    retval = sfldesc(sfield, &sfdsc);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) sfdsc.sf_fld);
	    str_numset(st[3], (double) sfdsc.sf_col);
	    str_numset(st[4], (double) sfdsc.sf_lin);
	}
	return sp;


/*** NOTE! NEEDS MORE CODE ***/
    case US_sfncitm:
	if (items != 1)
	    fatal("Usage: &sfncitm($(*funcname)())");
	else {
	    int retval;
	    int		(*funcname)() =	(int)		str_gnum(st[1]);

	    retval = sfncitm((*funcname)());
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_sfrstrec:
	if (items != 2)
	    fatal("Usage: &sfrstrec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = sfrstrec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_slastrec:
	if (items != 2)
	    fatal("Usage: &slastrec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = slastrec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_snextrec:
	if (items != 2)
	    fatal("Usage: &snextrec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = snextrec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_sprevrec:
	if (items != 2)
	    fatal("Usage: &sprevrec($field, $rfield)");
	else {
	    int retval;
	    int		field =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);

	    retval = sprevrec(field, rfield);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_startltg:
	if (items != 0)
	    fatal("Usage: &startltg()");
	else {
	    int retval;

	    retval = startltg();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_startrans:
	if (items != 0)
	    fatal("Usage: &startrans()");
	else {
	    int retval = 1;

	    (void)startrans();
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_strcmp:
	if (items != 2)
	    fatal("Usage: &strcmp($str1, $str2)");
	else {
	    int retval;
	    char*	str1 =		(char*)		str_get(st[1]);
	    char*	str2 =		(char*)		str_get(st[2]);

	    retval = strcmp(str1, str2);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_ufsel:
	if (items != 3)
	    fatal("Usage: &ufsel($tnum, $count, $(*tfunc)())");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    long	count;
	    int		(*tfunc)() =	(int)		str_gnum(st[3]);

	    retval = ufsel(tnum, &count, (*tfunc)());
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) count);
	}
	return sp;
#endif
    case US_ufsel:
	if (items != 3)
	    fatal("Usage: &ufsel($tnum, $count, 'tfunc')");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    long	count;
	    char	*funcname =	(char*)		str_get(st[3]);

		Subroutine = funcname;
		Stack_Pointer = sp;
	    retval = ufsel(tnum, &count, execute_subroutine);
	    str_numset(st[0], (double) retval);
	    str_numset(st[2], (double) count);
	}
	return sp;


    case US_ulockrec:
	if (items != 1)
	    fatal("Usage: &ulockrec($tnum)");
	else {
	    int retval = 1;
	    int		tnum =		(int)		str_gnum(st[1]);

	    (void)ulockrec(tnum);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_unisel:
	if (items != 3)
	    fatal("Usage: &unisel($selfile, $tnum, $count)");
	else {
	    int retval;
	    char*	selfile =	(char*)		str_get(st[1]);
	    int		tnum =		(int)		str_gnum(st[2]);
	    long	count;

	    retval = unisel(selfile, tnum, &count);
	    str_numset(st[0], (double) retval);
	    str_numset(st[3], (double) count);
	}
	return sp;


/*** NOTE! NEEDS MORE CODE ***/
    case US_unisort:
	if (items != 4)
	    fatal("Usage: &unisort($tnum, $rfield, $fldtbl, $functbl)");
	else {
	    int retval;
	    int		tnum =		(int)		str_gnum(st[1]);
	    int		rfield =	(int)		str_gnum(st[2]);
	    int*	fldtbl =	(int*)		str_gnum(st[3]);
	    int*	functbl =	(int*)		str_gnum(st[4]);

	    retval = unisort(tnum, rfield, fldtbl, functbl);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_unlock_r:
	if (items != 1)
	    fatal("Usage: &unlock_r($c)");
	else {
	    int retval;
	    char	c =		(char)		str_gnum(st[1]);

	    retval = unlock_r(c);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_unlock_r:
	if (items != 1)
	    fatal("Usage: &unlock_r($c)");
	else {
	    int retval;
	    char*	c =		(char)		str_get(st[1]);

	    retval = unlock_r(*c);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_uqmtch:
	if (items != 5)
	    fatal("Usage: &uqmtch($sf, $field, $rfield, $msf, $count)");
	else {
	    int retval;
	    char*	sf =		(char*)		str_get(st[1]);
	    int		field =		(int)		str_gnum(st[2]);
	    int		rfield =	(int)		str_gnum(st[3]);
	    char*	msf =		(char*)		str_get(st[4]);
	    long	count;

	    retval = uqmtch(sf, field, rfield, msf, &count);
	    str_numset(st[0], (double) retval);
	    str_numset(st[5], (double) count);
	}
	return sp;


#if 0
    case US_uqsrch:
	if (items != 6)
	    fatal("Usage: &uqsrch($sf, $field, $val1, $val2, $mode, $count)");
	else {
	    int retval;
	    char*	sf =		(char*)		str_get(st[1]);
	    int		field =		(int)		str_gnum(st[2]);
	    char*	val1 =		(char*)		str_to_field_buf(field, st[3]);
	    char*	val2 =		(char*)		str_to_field_buf(field, st[4]);
	    int		mode =		(int)		str_gnum(st[5]);
	    long	count;

	    retval = uqsrch(sf, field, val1, val2, mode, &count);
	    str_numset(st[0], (double) retval);
	    str_numset(st[6], (double) count);
	}
	return sp;
#endif
    case US_uqsrch:
	if (items != 6)
	    fatal("Usage: &uqsrch($sf, $field, $val1, $val2, $mode, $count)");
	else {
	    int retval;
	    char*	sf =		(char*)		str_get(st[1]);
	    int		field =		(int)		str_gnum(st[2]);
	    char*	val1;
	    char*	val2;
	    int		mode =		(int)		str_gnum(st[5]);
	    long	count;
		char	buf[256];

	    val1 = (char*)str_to_field_buf(field, st[3]);
		if (val1) {
			Move(val1, buf, sizeof(buf), char);
			val1 = buf;
		}
	    val2 = (char*)str_to_field_buf(field, st[4]);

	    retval = uqsrch(sf, field, val1, val2, mode, &count);
	    str_numset(st[0], (double) retval);
	    str_numset(st[6], (double) count);
	}
	return sp;


#if 0
    case US_valchar:
	if (items != 2)
	    fatal("Usage: &valchar($c, $str)");
	else {
	    int retval;
	    char	c =		(char)		str_gnum(st[1]);
	    char*	str =		(char*)		str_get(st[2]);

	    retval = valchar(c, str);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_valchar:
	if (items != 2)
	    fatal("Usage: &valchar($c, $str)");
	else {
	    int retval;
	    char*	c =		(char*)		str_get(st[1]);
	    char*	str =	(char*)		str_get(st[2]);

	    retval = valchar(*c, str);
	    str_numset(st[0], (double) retval);
	}
	return sp;


#if 0
    case US_valstr:
	if (items != 2)
	    fatal("Usage: &valstr($str, $set)");
	else {
	    int retval;
	    char*	str =		(char*)		str_get(st[1]);
	    char**	set =		(char**)	str_gnum(st[2]);

	    retval = valstr(str, set);
	    str_numset(st[0], (double) retval);
	}
	return sp;
#endif
    case US_valstr:
	if (items < 2)
	    fatal("Usage: &valstr($str, @set)");
	else {
	    int retval;
		int i;
	    char*	str =		(char*)		str_get(st[1]);
		char**  set =		alloca(items*sizeof(char*));

		for (i=2; i <= items; i++) {
	    	char *s = (char*)str_get(st[i]);
			set[i-2] = s;
		}
		set[items] = NULL;

	    retval = valstr(str, set);
	    str_numset(st[0], (double) retval);
	}
	return sp;


    case US_yorn:
	if (items != 1)
	    fatal("Usage: &yorn($str)");
	else {
	    int retval;
	    char*	str =		(char*)		str_get(st[1]);

	    retval = yorn(str);
	    str_numset(st[0], (double) retval);
	}
	return sp;



    default:
		fatal("Unimplemented user-defined subroutine");
		break;

    }
    return sp;
}

static int
userval(ix, str)
int ix;
STR *str;
{
	extern int _No_Umsgs;

    switch (ix) {
    case UV_No_Umsgs:
		str_numset(str, (double)_No_Umsgs);
		break;
    }
    return 0;
}

static int
userset(ix, str)
int ix;
STR *str;
{
	extern int _No_Umsgs;

    switch (ix) {
    case UV_No_Umsgs:
		_No_Umsgs = (int)str_gnum(str);
		break;
    }
    return 0;
}

int
userinit()
{
	init_uhli();
}

static int
str_buf_set(st, type, buf, slen)
register STR **st;
int type;
register char *buf;
int slen;
{
	if (buf == NULL) {
		*st = &str_undef;
		return;
	}

	switch (type) {
	case INT:
		str_numset(*st, (double) (*(short *)buf));
		break;
	case LONG:
		str_numset(*st, (double) (*(long *)buf));
		break;
	case FLT:
		str_numset(*st, (double) (*(double *)buf));
		break;
	case AMT:
		str_numset(*st, (double) (*(long *)buf) / 100.0);
		break;
	case HAMT:
		str_numset(*st, (double) (*(double *)buf));
		break;
	case DATE:
		str_numset(*st, (double) (*(short *)buf));
		break;
	case LDATE:
		str_numset(*st, (double) (*(long *)buf));
		break;
	case HR:
		str_numset(*st, (double) (*(short *)buf));
		break;
	case STRNG:
		{	int l = lastchr(buf, slen);
			str_nset(*st, (char*) buf, l);
		}
		break;
	case TEXT:
		str_nset(*st, (char*) buf, sizeof(buf));
		break;
	case BINARY:
		str_nset(*st, (char*) buf, sizeof(buf));
		break;
	case COMB:
		str_nset(*st, (char*) buf, sizeof(buf));
		break;
	}
}

static int
str_field_buf_set(st, field, buf)
register STR **st;
int field;
register char *buf;
{
	FLDESC fdsc;

	if (fldesc(field, &fdsc)) {
		str_buf_set(st, fdsc.f_typ, buf, fdsc.f_len);
	} else {
		str_nset(*st, (char*) buf, sizeof(buf));
	}
}

static int
str_sfld_buf_set(st, sfld, buf)
register STR **st;
int sfld;
register char *buf;
{
	SFLDESC sfdsc;
	FLDESC fdsc;

	if (sfldesc(sfld, &sfdsc) && fldesc(sfdsc.sf_fld, &fdsc)) {
		str_buf_set(st, fdsc.f_typ, buf, fdsc.f_len);
	} else {
		str_nset(*st, (char*) buf, sizeof(buf));
	}
}

static char *
str_to_buf(type, st)
int type;
register STR *st;
{
	static char store[256];
	register char *buf = store;
	register STR *Str;	/* for str_get and str_gnum macros */

	if (st == &str_undef) return (char *)0;

	bzero(store, sizeof(store));
	Move((char*)str_get(st), buf, st->str_cur, char);

	switch (type) {
	case INT:
		*(short *)buf = (short)str_gnum(st);
		break;
	case LONG:
		*(long *)buf = (long)str_gnum(st);
		break;
	case FLT:
		*(double *)buf = (double)str_gnum(st);
		break;
	case AMT:
		*(long *)buf = (long)((double)str_gnum(st) * 100.0);
		break;
	case HAMT:
		*(double *)buf = (double)str_gnum(st);
		break;
	case DATE:
		*(short *)buf = (short)str_gnum(st);
		break;
	case LDATE:
		*(long *)buf = (long)str_gnum(st);
		break;
	case HR:
		*(short *)buf = (short)str_gnum(st);
		break;
	case STRNG:
		break;
	case TEXT:
		fatal("Can't use str_to_buf on a TEXT field (yet ;-)");
		break;
	case BINARY:
		fatal("Can't use str_to_buf on a BINARY field (yet ;-)");
		break;
	case COMB:
		fatal("Can't use str_to_buf on a COMB field (yet ;-)");
		break;
	}

	return store;
}

static char *
str_to_field_buf(field, st)
int field;
register STR *st;
{
	FLDESC fdsc;

	if (fldesc(field, &fdsc))
		return str_to_buf(fdsc.f_typ, st);

	return (char *)0;
}

static char *
str_to_sfld_buf(sfld, st)
int sfld;
register STR *st;
{
	SFLDESC sfdsc;
	FLDESC fdsc;

	if (sfldesc(sfld, &sfdsc) && fldesc(sfdsc.sf_fld, &fdsc))
		return str_to_buf(fdsc.f_typ, st);

	return (char *)0;
}

/* Shamelessly snatched from perl-4.035/usub/usersub.c */
/* Be sure to refetch the stack pointer after calling these routines. */

static int
callback(subname, sp, gimme, hasargs, numargs)
char *subname;
int sp;			/* stack pointer after args are pushed */
int gimme;		/* called in array or scalar context */
int hasargs;		/* whether to create a @_ array for routine */
int numargs;		/* how many args are pushed on the stack */
{
    static ARG myarg[3];	/* fake syntax tree node */
    int arglast[3];
    
    arglast[2] = sp;
    sp -= numargs;
    arglast[1] = sp--;
    arglast[0] = sp;

    if (!myarg[0].arg_ptr.arg_str)
	myarg[0].arg_ptr.arg_str = str_make("",0);

    myarg[1].arg_type = A_WORD;
    myarg[1].arg_ptr.arg_stab = stabent(subname, FALSE);

    myarg[2].arg_type = hasargs ? A_EXPR : A_NULL;

    return do_subr(myarg, gimme, arglast);
}

static int
callv(subname, sp, gimme, argv)
char *subname;
register int sp;	/* current stack pointer */
int gimme;		/* called in array or scalar context */
register char **argv;	/* null terminated arg list, NULL for no arglist */
{
    register int items = 0;
    int hasargs = (argv != 0);

    astore(stack, ++sp, Nullstr);	/* reserve spot for 1st return arg */
    if (hasargs) {
	while (*argv) {
	    astore(stack, ++sp, str_2mortal(str_make(*argv,0)));
	    items++;
	    argv++;
	}
    }
    return callback(subname, sp, gimme, hasargs, items);
}

static int
execute_subroutine()
{
	return callv(Subroutine, Stack_Pointer, 0, NULL);
}
