require "unify/dbtypes.ph";

sub Init_Globals
{
	$first = 1;
	$next = 2;
	$only = 3;
	$prev = 4;
	$last = 5;
	$FN = 1;
	$FS = 2;
	$RN = 4;
	$RS = 8;
	$SS = -1;

	$DbTypes[$INT] = "Integer";
	$DbTypes[$LONG] = "Long";
	$DbTypes[$DATE] = "Date";
	$DbTypes[$AMT] = "Amount";
	$DbTypes[$STRNG] = "String";
	$DbTypes[$HAMT] = "Huge Amount";
	$DbTypes[$HR] = "Time";
	$DbTypes[$FLT] = "Float";
	$DbTypes[$TEXT] = "Text";
	$DbTypes[$BINARY] = "Binary";
	$DbTypes[$LDATE] = "Long Date";
	$DbTypes[$COMB] = "Comb";
}

sub Init_Tables
{
	$last_rec = &numrecs;

	print "Reading table information\n";

	$recs = "";
	$Table[0] = "";
	for ($rec=1; $rec <= $last_rec; $rec++) {
		$name = &recname($rec);
		$recs .= "\$$name = $rec;\n";
		$Table[$rec] = $name;
	}

	eval "$recs";
}

sub Init_Fields
{
	$last_fld = &numflds;

	print "Reading fields information\n";

	$flds = "";
	$Field[0] = "";
	for ($fld=1; $fld <= $last_fld; $fld++) {
		$name = &fldname($fld);
		$flds .= "\$$name = $fld;\n";
		$Field[$fld] = $name;
	}

	eval "$flds";
}

sub Init_Synonyms
{
	local($last_fld) = &numflds;
	local($name, $fld, $tid, $table, $fdsc);

	print "Reading synonyms information\n";

	local($flds) = "";
	$Synonym[0] = "";
	for ($fld=1; $fld <= $last_fld; $fld++) {
		&fldesc($fld, $f_rec, $f_typ, $f_len, $f_par, $f_rprec, $f_rpfld);
		$table = &recname($f_rec);
		$name = &fldsyn($fld);
		$flds .= "\$$table{'$name'} = $fld;\n";
		$flds .= "\$fldid{'$table.$name'} = $fld;\n";
		$Synonym[$fld] = "$table.$name";
	}

	eval "$flds";
}

1;
